// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package zone

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ZoneClient is the client API for Zone service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ZoneClient interface {
	// ZoneStatus returns the status of the zone
	ZoneStatus(ctx context.Context, in *ZoneStatusRequest, opts ...grpc.CallOption) (*ZoneStatusReply, error)
}

type zoneClient struct {
	cc grpc.ClientConnInterface
}

func NewZoneClient(cc grpc.ClientConnInterface) ZoneClient {
	return &zoneClient{cc}
}

func (c *zoneClient) ZoneStatus(ctx context.Context, in *ZoneStatusRequest, opts ...grpc.CallOption) (*ZoneStatusReply, error) {
	out := new(ZoneStatusReply)
	err := c.cc.Invoke(ctx, "/zone.Zone/ZoneStatus", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ZoneServer is the server API for Zone service.
// All implementations must embed UnimplementedZoneServer
// for forward compatibility
type ZoneServer interface {
	// ZoneStatus returns the status of the zone
	ZoneStatus(context.Context, *ZoneStatusRequest) (*ZoneStatusReply, error)
	mustEmbedUnimplementedZoneServer()
}

// UnimplementedZoneServer must be embedded to have forward compatible implementations.
type UnimplementedZoneServer struct {
}

func (UnimplementedZoneServer) ZoneStatus(context.Context, *ZoneStatusRequest) (*ZoneStatusReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ZoneStatus not implemented")
}
func (UnimplementedZoneServer) mustEmbedUnimplementedZoneServer() {}

// UnsafeZoneServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ZoneServer will
// result in compilation errors.
type UnsafeZoneServer interface {
	mustEmbedUnimplementedZoneServer()
}

func RegisterZoneServer(s grpc.ServiceRegistrar, srv ZoneServer) {
	s.RegisterService(&Zone_ServiceDesc, srv)
}

func _Zone_ZoneStatus_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ZoneStatusRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ZoneServer).ZoneStatus(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/zone.Zone/ZoneStatus",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ZoneServer).ZoneStatus(ctx, req.(*ZoneStatusRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Zone_ServiceDesc is the grpc.ServiceDesc for Zone service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Zone_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "zone.Zone",
	HandlerType: (*ZoneServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ZoneStatus",
			Handler:    _Zone_ZoneStatus_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "zone-api/zone/zone.proto",
}
